Bug 1410366 - Unify spec file with upstream
Summary: Unify spec file with upstream
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: graphviz
Version: 26
Hardware: All
OS: Linux
low
medium
Target Milestone: ---
Assignee: Jaroslav Škarvada
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 530965
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-01-05 10:25 UTC by Jaroslav Škarvada
Modified: 2018-05-29 11:55 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 530965
Environment:
Last Closed: 2018-05-29 11:55:00 UTC
Type: ---


Attachments (Terms of Use)

Description Jaroslav Škarvada 2017-01-05 10:25:06 UTC
+++ This bug was initially created as a clone of Bug #530965 +++

User-Agent:       Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.0.14) Gecko/2009090923 Red Hat/3.0.14-1.el5_4 Firefox/3.0.14

Hello,

Several of our users report problems with graphviz, all fixed in the latest
stable version 2.24.0-1. In addition, there is a security problem that might
affect the current EPEL version (*).

Could you please consider upgrading this packages?


                  best regards, Jan


(*) http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2008-4555

Reproducible: Always

--- Additional comment from Patrick Laughton on 2009-12-18 18:54:44 CET ---

I wonder how much people would hate me if I copied the one I'm working on from Rawhide (2.26.0) to EPEL.

--- Additional comment from Fulko Hew on 2010-08-09 20:07:25 CEST ---

(In reply to comment #1)
> I wonder how much people would hate me if I copied the one I'm working on from
> Rawhide (2.26.0) to EPEL.    

I just encountered a problem in my RHEL system because I needed something newer than the version (2.12) currently found on EPEL.  I need PNG support.

Therefore any current version would suit my needs.

--- Additional comment from Mark Chappell on 2010-09-23 12:21:43 CEST ---

Patrick:

Two problems with doing that

1) Missing dependencies
1a) swig >= 1.3.33  (1.3.29 is shipped in RHEL5.5)
1b) DevIL (which in turn requires allegro)

2) ABI changes (various libraries shipped by graphviz have bumped their version numbers)

However,
* According to the website it looks like swig 1.3.33 isn't actual requirement 1.3.29 is...
* DevIL and allegro seem happy to build.
* Nothing in EPEL depends on those libs, I suspect we would get away with updating...

--- Additional comment from Tomas Hoger on 2015-05-20 13:41:40 CEST ---

Re-setting assignee, as this component changed owner since this bug was created.

--- Additional comment from John Ellson on 2017-01-04 18:55:14 CET ---

From upstream - Thank you very much, Jaroslav, for taking on graphviz packaging in Redhat. I see the nice new rpms in Rawhide :-)

I wonder if we could have a discussion on unifying the upstream and rawhide spec files?   In particular, we have departed on package naming.  Is this ticket a good place for this discussion?



Re Comment#3.  RHEL5 only has swig-1.3.29,  which we use as best we can. But for
the graphviz  R language extension swig 1.3.33 is required.

AFAIK, R itself is usable on RHEL5, its just the swig issue.  Its not an issue that I've been worrying about.  I suspect the set of R users on RHEL5 that would like to use graphviz from an R program, is quite small.


Re Comment#2.  RPMs are available from upstream for RHEL5, from www.graphviz.org.

--- Additional comment from Jaroslav Škarvada on 2017-01-05 11:23:53 CET ---

(In reply to John Ellson from comment #5)
> From upstream - Thank you very much, Jaroslav, for taking on graphviz
> packaging in Redhat. I see the nice new rpms in Rawhide :-)
> 
Hi, I packaged it once it got stable.

> I wonder if we could have a discussion on unifying the upstream and rawhide
> spec files?   In particular, we have departed on package naming.  Is this
> ticket a good place for this discussion?
> 
NP, I am going to clone this ticket for the subject to be e.g. better searchable.

Closing this one because it seems obsoleted. There is graphviz-2.40.1 already in rawhide.

Comment 1 Jaroslav Škarvada 2017-01-05 10:34:34 UTC
> From upstream - Thank you very much, Jaroslav, for taking on graphviz
> packaging in Redhat. I see the nice new rpms in Rawhide :-)

NP, I am packaging new versions once it got stable.

> I wonder if we could have a discussion on unifying the upstream
> and rawhide spec files?   In particular, we have departed on package
> naming.  Is this ticket a good place for this discussion?

NP, IIRC there is a room for improvements and for e.g. better structuring of subpackages. Is there currently anything we do wrong? I am ready for fixing it or unification with upstream. Regarding renames, in Fedora it would require virtual provides not to break others using the oldpackages. And it's Fedora policy to keep the old provides for at least N+2 releases.

> Re Comment#3.  RHEL5 only has swig-1.3.29,  which we use as best we can. But for
> the graphviz  R language extension swig 1.3.33 is required.

Personally, I would probably not care too much about RHEL-5 now, it's too old.

Comment 2 John Ellson 2017-01-05 15:36:23 UTC
Rehat's spec file produces the following sub packages of graphviz:

$ grep %package graphviz.spec
%package devel
%package devil
%package doc
%package gd
%package graphs
%package guile
%package java
%package lua
%package ming
%package ocaml
%package perl
%package php
%package python
%package R
%package ruby
%package sharp
%package tcl


Please consider if the upstream's packages would be acceptable:

$ grep %package graphviz.spec
%package nox
%package libs
%package plugins-core
%package x
%package plugins-x
%package gd
%package plugins-gd
%package plugins-webp
%package plugins-devil
%package plugins-ming
%package qt
%package lang-sharp
%package lang-go
%package lang-guile
%package lang-io
%package lang-java
%package lang-lua
%package lang-ocaml
%package lang-perl
%package lang-php
%package lang-python
%package lang-R
%package lang-ruby
%package lang-tcl
%package devel
%package graphs
%package doc



I wanted to:
   - separate programming language bindings
   - separate libs
   - separate progs requiring x from those without x requires,  to provide a package for use on web servers.
   - separate optional plugins (rendering and input library extensions)


I believe the upstream spec correctly "Obsoletes" the old names.  I can install the upstream rpms over Redhat's without complaint.

I can see that there might be an issue with "lang" being hised for "computer languages" instead of "human languages".   Can you suggest a better term?

Comment 3 John Ellson 2017-01-05 15:44:21 UTC
There are some lesser issues with content of some of the packages,  for example:

Upstream's graphviz-lang-lua.rpm
    /usr/lib64/lua/5.3
    /usr/lib64/lua/5.3/gv.so
    /usr/share/graphviz/demo/modgraph.lua
    /usr/share/man/man3/gv.3lua.gz

Redhat's graphviz-lua.rpm
    /usr/lib64/graphviz/lua
    /usr/lib64/graphviz/lua/gv.so
    /usr/lib64/graphviz/lua/libgv_lua.so
    /usr/lib64/lua/5.3
    /usr/lib64/lua/5.3/gv.so
    /usr/share/man/man3/gv.3lua.gz


- no need for /usr/lib64/graphviz/lua
- demo script is missing

Comment 4 John Ellson 2017-01-05 15:53:08 UTC
I'm not sure if I understand "virtual provides"

The "plugins-*" packages are only usable by graphviz itself,  so I don't think a "virtual provides" would be need for those.

Perhaps virtual-provides are needed for the lang-* packages?

Something like:
     graphviz-lang-lua provides graphviz-lua?

Comment 5 Fedora End Of Life 2017-02-28 10:52:50 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 26 development cycle.
Changing version to '26'.

Comment 6 John Ellson 2017-07-19 15:52:55 UTC
Can I get a Red Hat opinion on our graphviz package naming, before I do a new stable release upstream?

In particular,  we currently have these names for the various script language extensions that provide access to graphviz facilities:

graphviz-lang-go-2.41.20170719.0420-1.fc26.x86_64.rpm
graphviz-lang-guile-2.41.20170719.0420-1.fc26.x86_64.rpm
graphviz-lang-java-2.41.20170719.0420-1.fc26.x86_64.rpm
graphviz-lang-lua-2.41.20170719.0420-1.fc26.x86_64.rpm
graphviz-lang-ocaml-2.41.20170719.0420-1.fc26.x86_64.rpm
graphviz-lang-perl-2.41.20170719.0420-1.fc26.x86_64.rpm
graphviz-lang-php-2.41.20170719.0420-1.fc26.x86_64.rpm
graphviz-lang-python2-2.41.20170719.0420-1.fc26.x86_64.rpm
graphviz-lang-python3-2.41.20170719.0420-1.fc26.x86_64.rpm
graphviz-lang-R-2.41.20170719.0420-1.fc26.x86_64.rpm
graphviz-lang-ruby-2.41.20170719.0420-1.fc26.x86_64.rpm
graphviz-lang-sharp-2.41.20170719.0420-1.fc26.x86_64.rpm
graphviz-lang-tcl-2.41.20170719.0420-1.fc26.x86_64.rpm


These seem reasonable to me as they indicate the upstream project first,
and perhaps emphasize that all these extensions are generated from a single swig "gv.i" template.

However these names are in conflict with, for example, the python guidelines for plugins:

   https://fedoraproject.org/wiki/Packaging:Naming?rd=Packaging:NamingGuidelines#Python_source_package_naming


If you felt strongly about this,  I think it would be possible to rename the packages to something like:

go-graphviz
guile-graphviz
java-graphviz
lua-graphviz
ocaml-graphviz
perl-graphviz
php-graphviz
python2-graphviz
python3-graphviz
R-graphviz
ruby-graphviz
sharp-graphviz
tcl-graphviz

As you can probably tell, my own preference is for the current naming,   but if you folks feel strongly about this,  please let me know?


Also, I would still like to unify the graphviz.spec file.   Now would be a good time to provide any other feedback on my upstream version.

(I suspect you think its a monster.  but there is only one for all RH distributions,  so from my POV the maintenance is simpler.)

Comment 7 Jaroslav Škarvada 2017-07-19 16:27:42 UTC
(In reply to John Ellson from comment #6)
> Can I get a Red Hat opinion on our graphviz package naming, before I do a
> new stable release upstream?
> 
> In particular,  we currently have these names for the various script
> language extensions that provide access to graphviz facilities:
> 
> graphviz-lang-go-2.41.20170719.0420-1.fc26.x86_64.rpm
> graphviz-lang-guile-2.41.20170719.0420-1.fc26.x86_64.rpm
> graphviz-lang-java-2.41.20170719.0420-1.fc26.x86_64.rpm
> graphviz-lang-lua-2.41.20170719.0420-1.fc26.x86_64.rpm
> graphviz-lang-ocaml-2.41.20170719.0420-1.fc26.x86_64.rpm
> graphviz-lang-perl-2.41.20170719.0420-1.fc26.x86_64.rpm
> graphviz-lang-php-2.41.20170719.0420-1.fc26.x86_64.rpm
> graphviz-lang-python2-2.41.20170719.0420-1.fc26.x86_64.rpm
> graphviz-lang-python3-2.41.20170719.0420-1.fc26.x86_64.rpm
> graphviz-lang-R-2.41.20170719.0420-1.fc26.x86_64.rpm
> graphviz-lang-ruby-2.41.20170719.0420-1.fc26.x86_64.rpm
> graphviz-lang-sharp-2.41.20170719.0420-1.fc26.x86_64.rpm
> graphviz-lang-tcl-2.41.20170719.0420-1.fc26.x86_64.rpm
> 
> 
> These seem reasonable to me as they indicate the upstream project first,
> and perhaps emphasize that all these extensions are generated from a single
> swig "gv.i" template.
> 
> However these names are in conflict with, for example, the python guidelines
> for plugins:
> 
>   
> https://fedoraproject.org/wiki/Packaging:Naming?rd=Packaging:
> NamingGuidelines#Python_source_package_naming
> 
> 
> If you felt strongly about this,  I think it would be possible to rename the
> packages to something like:
> 
> go-graphviz
> guile-graphviz
> java-graphviz
> lua-graphviz
> ocaml-graphviz
> perl-graphviz
> php-graphviz
> python2-graphviz
> python3-graphviz
> R-graphviz
> ruby-graphviz
> sharp-graphviz
> tcl-graphviz
> 
> As you can probably tell, my own preference is for the current naming,   but
> if you folks feel strongly about this,  please let me know?
> 
> 
> Also, I would still like to unify the graphviz.spec file.   Now would be a
> good time to provide any other feedback on my upstream version.
> 
> (I suspect you think its a monster.  but there is only one for all RH
> distributions,  so from my POV the maintenance is simpler.)

AFAIK according to [1] for Fedora and language bindings the correct approach is the second one (i.e. python2-graphviz, etc.). I know there are still packages in Fedora repo which have it wrong. Regarding the unification of the spec file, could we move the discussion to fedora-devel mailing list? There could arise some interesting ideas.

[1] https://fedoraproject.org/wiki/Packaging:Naming?rd=Packaging:NamingGuidelines#Addon_Packages

Comment 8 Fedora End Of Life 2018-05-03 08:12:20 UTC
This message is a reminder that Fedora 26 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 26. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '26'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 26 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 9 Fedora End Of Life 2018-05-29 11:55:00 UTC
Fedora 26 changed to end-of-life (EOL) status on 2018-05-29. Fedora 26
is no longer maintained, which means that it will not receive any
further security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.